searchNodes=[{"doc":"Handy little queues and producers.","ref":"Queutils.html","title":"Queutils","type":"module"},{"doc":"A GenStage producer that acts as a blocking queue, with a fixed length. Blocks any time Queutils.BlockingProducer.push/2 is called when the queue is at its maximum length.This can be used as an entry-point to a GenStage pipeline, since the max queue length provides for back-pressure. You can even set the queue's length to zero in order to block all pushes until demand comes in.UsageAdd it to your application supervisor's start/2 function like this:def start(_type, _args) do children = [ ... {Queutils.BlockingProducer, name: MessageProducer, max_length: 10_000}, ... ] opts = [strategy: :one_for_one, name: MyApplication.Supervisor] Supervisor.start_link(children, opts) endThen, you can push messages to the queue like this::ok = Queutils.BlockingProducer.push(MessageProducer, :my_message)Broadway users be forewared! A Broadway module needs to start its producer itself, so it's not possible to customize the process ID a la the :name option documented below. If you're in that boat, you should use a Queutils.BlockingQueue along with a Queutils.BlockingQueueProducer, so you can customize your reference to your BlockingQueue.Options:name - the ID of the queue. This will be the first argument to the push/2 function.:max_length - The maximum number of messages that this process will store until it starts blocking. Default is 1,000.:dispatcher - The GenStage dispatcher that this producer should use. Default is GenStage.DemandDispatcher.","ref":"Queutils.BlockingProducer.html","title":"Queutils.BlockingProducer","type":"module"},{"doc":"Push an item onto the queue. This function will block if the queue is full, and unblock once it's not.","ref":"Queutils.BlockingProducer.html#push/2","title":"Queutils.BlockingProducer.push/2","type":"function"},{"doc":"","ref":"Queutils.BlockingProducer.html#start_link/1","title":"Queutils.BlockingProducer.start_link/1","type":"function"},{"doc":"A queue with a fixed length that blocks on Queutils.BlockingQueue.push/2 if the queue is full.UsageAdd it to your application supervisor's start/2 function, like this:def start(_type, _args) do children = [ ... {Queutils.BlockingQueue, name: MessageQueue, max_length: 10_000}, ... ] opts = [strategy: :one_for_one, name: MyApplication.Supervisor] Supervisor.start_link(children, opts) endThen you can push and pop from the queue like this::ok = Queutils.Blockingqueue.push(MessageQueue, :my_message) [:my_message] = Queutils.Blockingqueue.pop(MessageQueue, 1)Use with Queutils.BlockingQueueProducer for more fun, or use Queutils.BlockingProducer for the effect of both.Options:name - the ID of the queue. This will be the first argument to the push/2 function. Default is BlockingQueue.:max_length - The maximum number of messages that this process will store until it starts blocking. Default is 1,000.","ref":"Queutils.BlockingQueue.html","title":"Queutils.BlockingQueue","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Queutils.BlockingQueue.html#child_spec/1","title":"Queutils.BlockingQueue.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Queutils.BlockingQueue.html#init/1","title":"Queutils.BlockingQueue.init/1","type":"function"},{"doc":"Get the current length of the queue.","ref":"Queutils.BlockingQueue.html#length/1","title":"Queutils.BlockingQueue.length/1","type":"function"},{"doc":"Pop an item off of the queue. Never blocks, and returns a list. The returned list will be empty if the queue is empty.","ref":"Queutils.BlockingQueue.html#pop/2","title":"Queutils.BlockingQueue.pop/2","type":"function"},{"doc":"Push an item onto the queue. This function will block if the queue is full, and unblock once it's not.","ref":"Queutils.BlockingQueue.html#push/2","title":"Queutils.BlockingQueue.push/2","type":"function"},{"doc":"Start a blocking queue process.Options:name - the ID of the queue. This will be the first argument to the push/2 function. Default is BlockingQueue.:max_length - The maximum number of messages that this process will store until it starts blocking. Default is 1,000.","ref":"Queutils.BlockingQueue.html#start_link/1","title":"Queutils.BlockingQueue.start_link/1","type":"function"},{"doc":"A GenStage producer that polls a Queutils.BlockingQueue at a fixed interval, emitting any events on the queue.UsageAdd it to your application supervisor's start/2 function, after the queue it pulls from, like this:def start(_type, _args) do children = [ ... {Queutils.BlockingQueue, name: MessageQueue, max_length: 10_000}, {Queutils.BlockingQueueProducer, name: MessageProducer}, ... ] opts = [strategy: :one_for_one, name: MyApplication.Supervisor] Supervisor.start_link(children, opts) endThe subscribe a consumer to it, like any other GenStage producer.def init(_opts) do {:consumer, :my_consumer_state, [subscribe_to: MessageProducer]} endOptions:name - the ID of the queue. This will be the first argument to the push/2 function. Default is BlockingQueueProducer.:max_length - The maximum number of messages that this process will store until it starts blocking. Default is 1,000.:dispatcher - The GenStage dispatcher that this producer should use. Default is GenStage.DemandDispatcher.","ref":"Queutils.BlockingQueueProducer.html","title":"Queutils.BlockingQueueProducer","type":"module"},{"doc":"Start a blocking queue producer.Options:name - the ID of the queue. This will be the first argument to the push/2 function. Default is BlockingQueueProducer.:max_length - The maximum number of messages that this process will store until it starts blocking. Default is 1,000.:dispatcher - The GenStage dispatcher that this producer should use. Default is GenStage.DemandDispatcher.","ref":"Queutils.BlockingQueueProducer.html#start_link/1","title":"Queutils.BlockingQueueProducer.start_link/1","type":"function"},{"doc":"QueutilsHandy little queues and producers to make using GenStage a breeze.","ref":"readme.html","title":"Queutils","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding queutils to your list of dependencies in mix.exs:def deps do [ {:queutils, &quot;~&gt; 0.1.0&quot;} ] endDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/queutils.","ref":"readme.html#installation","title":"Queutils - Installation","type":"extras"}]